<!DOCTYPE html>
<html lang="zh-CN">
<head>
    <script src="https://cdn.jsdelivr.net/npm/marked/marked.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/dompurify/3.0.5/purify.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.7.0/styles/atom-one-dark.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.7.0/highlight.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.7.0/languages/php.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.7.0/languages/java.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.7.0/languages/cpp.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.7.0/languages/python.min.js"></script>
<!--<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.7.0/languages/javascript.min.js"></script>-->
<meta charset="UTF-8">
<title>帖子详情-✨CodeCraft💡用热爱🔥编写未来🌅</title>
<style>
body{
 background: #003973;  /* fallback for old browsers */
background: -webkit-linear-gradient(to top, #003973, #E5E5BE);  /* Chrome 10-25, Safari 5.1-6 */
background: linear-gradient(to top, #E5E5BE, #003973); /* W3C, IE 10+/ Edge, Firefox 16+, Chrome 26+, Opera 12+, Safari 7+ */

 }
.post {
    background-color: white;
    margin: 20px auto;
    padding:10px;
    width:860px;
    border-radius: 5px;
    box-shadow:15px 10px 10px rgba(0, 0, 0, 0.175);
}
.post h3 {
    margin-top:6px;
    margin-bottom:4px;
}
.post small {
    color: gray;
}
#post{
    display:none;
    font-size:14px;
    margin-top: 10px;
font-family: 'Segoe UI', system-ui, sans-serif;
}

		/* 导航条 */
			.topnav {
			overflow: hidden;
			background-color: #333;
			top:0;
			padding:5px;
			position:sticky;
			position:-webkit-sticky;
		}
		/* 导航条链接 */
		.topnav a {
			float: left;
			display: block;
			color: #f2f2f2;
			text-align: center;
			padding: 14px 16px;
			text-decoration: none;
		}
		/* 链接颜色修改 */
		.topnav a:hover {
			background-color: #ddd;
			color: black;
		}
</style>
</head>
<body>
<div class="topnav">
	<a href="/v0.2/viewer.html" target="_blank">论坛bbs</a>
	<a href="/v0.2/editor.html" target="_blank">创作edit</a>
	<a href="/v0.2/index.html" target="_self">主页</a>
	<a href="/v0.2/sign-in-up.html" style="float:right" target="_self">登陆</a>
</div>
<?php
include 'db.php';
// 从URL获取帖子id并转换为整数
$tid = intval($_GET['id']);

// 准备SQL查询语句
$sql = "SELECT id, author, time, title, content , resume ,viewrate FROM posts WHERE id=? ORDER BY time DESC";
$stmt = $conn->prepare($sql); // 准备预处理语句
if ($stmt) {
    // 绑定参数并执行预处理语句
    $stmt->bind_param("i", $tid);
    $stmt->execute(); // 执行预处理语句
    $result = $stmt->get_result(); // 获取结果集

    if ($result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            echo '<div class="post">';
            echo '<h3>' . htmlspecialchars($row['title']) . '</h3>';
            echo '<small><b>' . htmlspecialchars($row['author']) . '</b>  |  <i>' . htmlspecialchars($row['time']) . '</i></small>';
            echo "<b style='color:lightblue;font-size:16px;margin-left:35px;'><i>".htmlspecialchars($row['viewrate'])."人👁浏览</i></b><br/>";
            echo '<span id="post" style="white-space: pre-wrap;overflow-wrap: break-word;">' . htmlspecialchars($row['content']) . '</span>';
            echo '<div id="preview" class="post"></div>';
            echo '</div>';
        }
    } else {
        echo "No posts found.";
    }

    // 关闭预处理语句和连接
    $stmt->close();
    $conn->close();
} else {
    // 处理准备语句失败的情况
    die('Error preparing statement: ' . $conn->error);
}
?>
    <script>
        // 初始化Markdown解析器
marked.setOptions({
  breaks: true,
  highlight: function(code, language) {
    // 如果语言未指定，则自动检测
    const validLanguage = hljs.getLanguage(language) ? language : 'plaintext';
    return hljs.highlight(code, { language: validLanguage }).value;
  }
});
        // 更新预览
function updatePreview() {
  const rawText = document.getElementById('post').value;
  const sanitized = DOMPurify.sanitize(marked.parse(rawText));
  document.getElementById('preview').innerHTML = sanitized;
  
  // 新增：手动触发代码块高亮
  document.querySelectorAll('#preview pre code').forEach((block) => {
    hljs.highlightElement(block);
  });
}

        // 初始预览更新
        updatePreview();
    </script>
</body>
</html>